package com.goldenwater.slaj.sins.controller;

import com.goldenwater.common.annotation.Log;
import com.goldenwater.common.core.controller.BaseController;
import com.goldenwater.common.core.domain.AjaxResult;
import com.goldenwater.common.core.page.TableDataInfo;
import com.goldenwater.common.enums.BusinessType;
import com.goldenwater.common.utils.poi.ExcelUtil;
import com.goldenwater.slaj.hidd.domain.BisSinsSche;
import com.goldenwater.slaj.hidd.service.IBisSinsScheService;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/sins/sinssche")
public class BisSinsScheController extends BaseController {
    @Autowired
    private IBisSinsScheService bisSinsScheService;

    @GetMapping("/list")
    public TableDataInfo list(BisSinsSche bisSinsSche) {
        startPage();
        List<BisSinsSche> list = bisSinsScheService.selectBisSinsScheList(bisSinsSche);
        return getDataTable(list);
    }

    @GetMapping("/{guid}")
    public AjaxResult getInfo(@PathVariable String guid) {
        return AjaxResult.success(bisSinsScheService.selectBisSinsScheByGuid(guid));
    }

    @PostMapping
    public AjaxResult add(@RequestBody BisSinsSche bisSinsSche) {
        return toAjax(bisSinsScheService.insertBisSinsSche(bisSinsSche));
    }

    @PutMapping
    public AjaxResult edit(@RequestBody BisSinsSche bisSinsSche) {
        return toAjax(bisSinsScheService.updateBisSinsSche(bisSinsSche));
    }

    @DeleteMapping("/{guids}")
    public AjaxResult remove(@PathVariable String[] guids) {
        return toAjax(bisSinsScheService.deleteBisSinsScheByGuids(guids));
    }

    @Log(title = "检查方案明细管理", businessType = BusinessType.EXPORT)
    @PreAuthorize("@ss.hasPermi('sins:sinssche:export')")
    @PostMapping("/export")
    public void export(HttpServletResponse response, BisSinsSche bisSinsSche) {
        List<BisSinsSche> list = bisSinsScheService.selectBisSinsScheList(bisSinsSche);
        ExcelUtil<BisSinsSche> util = new ExcelUtil<BisSinsSche>(BisSinsSche.class);
        util.exportExcel(response, list, "检查方案明细管理数据");
    }
}
